/*
    NOM PAQUET: LOG_PKG
    
    DESCRIPCIÓ: Proporciona funcionalitat per a registrar les operacions realitzades sobre la BDD al LOG.
    
*/

CREATE OR REPLACE PACKAGE LOG_PKG AS
  --Insereix un registre al LOG on p_nomProc s el nom del procediment que ha registrat el LOG,
  --p_inParams sn els valors dels parmetres d'entrada, p_resExec el codi d'execucci del resultat.
  --La funci retorna un enter amb l'identificador del LOG registrat.
  FUNCTION REGISTRAR_LOG (p_nomProc VARCHAR2, p_inParams VARCHAR2, p_resExec INT) RETURN INT;
  
  --Mostra els darrers numero de LOG's que s'han registrat al sistema.
  PROCEDURE MOSTRAR_LOG (numero IN INT);
END LOG_PKG;
/

CREATE OR REPLACE PACKAGE BODY LOG_PKG IS

-----------------------------------------------
--          REGISTRAR_LOG                    --
-----------------------------------------------
  FUNCTION REGISTRAR_LOG (p_nomProc VARCHAR2, p_inParams VARCHAR2, p_resExec INT) RETURN INT IS
  BEGIN
      INSERT INTO EXEC_LOG VALUES (PROC_LOG_SEQ.nextval, systimestamp, p_nomProc, p_inParams, p_resExec);
      COMMIT;
      RETURN PROC_LOG_SEQ.currval;
  END;
  
-----------------------------------------------
--          MOSTRAR_LOG                    --
-----------------------------------------------
  PROCEDURE MOSTRAR_LOG (numero IN INT) IS
    p_RES int;
    p_ERRDESC VARCHAR2(150);
    cursor cLOG IS SELECT * FROM (SELECT * FROM EXEC_LOG ORDER BY idLog DESC) WHERE ROWNUM<numero ORDER BY idLog;
    idLog INT;
    timeLog DATE;
    procediment VARCHAR(150);
    params VARCHAR(500);
    resultLog INT;
  BEGIN
    dbms_output.put_line('');
    dbms_output.put_line('Entrades generades al LOG'); 
    dbms_output.put_line('id | dateTime | nom procediment | parametres entrada | resultat');
    OPEN cLOG;
    LOOP
      FETCH cLOG INTO idLog, timeLog,	procediment, params, resultLog;
      EXIT WHEN cLOG%NOTFOUND;
      dbms_output.put_line(idLOG||' | '||timeLOG||' | '||procediment||' | '||params||' | '||resultLOG);
    END LOOP;
    CLOSE cLOG;  
  END;
    
END LOG_PKG;