/******************************************
**         UPDATE_EST_VENTA              **
******************************************/
--Disparador que actualitza les taules parcials d'estadstiques cada vegada
--que hi ha una inserci, esborrat o actualitzaci d'una entrada sobre la taula
--de fets
  CREATE OR REPLACE TRIGGER TRIGGER_VENTA_EST AFTER
    INSERT OR
    UPDATE OR
    DELETE 
  ON VENTA
  FOR EACH ROW
DECLARE
  tAny NUMBER;
  tDia NUMBER;
  tHora NUMBER;
  tBenefici NUMBER;
  tUnitats NUMBER;
  tBotiga NUMBER;
  tCiutat NUMBER;
  tProducte NUMBER;
  tVirtual NUMBER;
BEGIN
  CASE
    WHEN INSERTING THEN
      tAny:=EXTRACT(YEAR FROM :NEW.dataVenta);
      tDia:=EXTRACT(DAY FROM :NEW.dataVenta);
      tHora:=:NEW.horaVenta;
      tBenefici:=:NEW.beneficiTotal;
      tUnitats:=:NEW.sumProducte;
      tBotiga:=:NEW.idBotiga;
      tProducte:=:NEW.idProducte;
    WHEN UPDATING THEN
      tAny:=EXTRACT(YEAR FROM :NEW.dataVenta);
      tDia:=EXTRACT(DAY FROM :NEW.dataVenta);
      tHora:=:NEW.horaVenta;
      tBenefici:=:NEW.beneficiTotal-:OLD.beneficiTotal;
      tUnitats:=:NEW.sumProducte-:OLD.sumProducte;
      tBotiga:=:NEW.idBotiga;
      tProducte:=:NEW.idProducte;
    WHEN DELETING THEN
      tAny:=EXTRACT(YEAR FROM :OLD.dataVenta);
      tDia:=EXTRACT(DAY FROM :OLD.dataVenta);
      tHora:=:OLD.horaVenta;
      tBenefici:=-:OLD.beneficiTotal;
      tUnitats:=-:OLD.sumProducte;
      tBotiga:=:OLD.idBotiga;
      tProducte:=:OLD.idProducte;
  END CASE;
  
  SELECT esVirtual, idCiutat INTO tVirtual,tCiutat FROM Botiga WHERE idBotiga=tBotiga;

  --Actualitzem les estadstiques desprs de qualsevol acci sobre la taula VENTA
  ESTADISTIC_PKG.ACTUALITZAR_EST_PARCIAL(tAny,tDia,tHora,tBenefici,tUnitats,tBotiga,
    tCiutat,tProducte,tVirtual);
  ESTADISTIC_PKG.ACTUALITZAR_EST_GLOBAL(tAny);
  --ESTADISTIC_PKG.ACTUALITZAR_BENEFICI_TOTAL(tAny,tBenefici);
  --La resta d'estadstiques globals s'actualitzaran a partir de disparadors a les estadstiques parcials
    
END;