declare
	p_RES int;
	p_ERRDESC VARCHAR2(150);

begin

--Desactivem els triggers...
EXECUTE IMMEDIATE 'ALTER TRIGGER TRIGGER_VENTA_EST DISABLE';

DELETE FROM ESTADISTICA;
DELETE FROM EST_BOTIGA;
DELETE FROM EST_CIUTAT;
DELETE FROM EST_DIA;
DELETE FROM EST_HORA;
DELETE FROM EST_PRODUCTE;
DELETE FROM EST_VIRTUAL;
DELETE FROM VENTA;
DELETE FROM PRODUCTE;
DELETE FROM BOTIGA;
DELETE FROM CIUTAT;
DELETE FROM REGIO;

--Poblem la BDD amb LES CIUTATS, I LES REGIONS
Insert into REGIO values ('10','Baix Llobregat');
Insert into REGIO values ('11','Baix Peneds');
Insert into REGIO values ('32','Selva');
Insert into REGIO values ('34','Tarragons');

Insert into CIUTAT values ('1','Abrera','10');
Insert into CIUTAT values ('29','Caldes de Malavella','32');
Insert into CIUTAT values ('69','La Canonja','34');
Insert into CIUTAT values ('78','L''Arbo','11');
Insert into CIUTAT values ('90','Maanet de la Selva','32');



/*************************************
*      BLOC DE PROVES PRODUCTE       *
*************************************/

--	AFEGIR PRODUCTE
dbms_output.put_line('TEST PRODUCTE'||chr(13)||chr(13));

--Afegir tres nous productes no han de donar cap error perqu no estan en catleg i les dades estan ben informades.
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002013,'Top combinado de seda en color negro. Tirantes ajustables.',
  to_date('10/01/2015', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002020,'Pantaln encerado en blanco. Cintura ancha, cierre con cremallera lateral.',
	'1/10/2015',p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002037,'Jersey de punto en color rojo con un pequeo calado. Manga larga. Cuello de pico.',
	'1/10/2015',p_RES,p_ERRDESC);

--Afegir tres nous productes. Han de donar error ja que ja existeixen
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002013,'Top combinado de seda en color negro. Tirantes ajustables.',
  to_date('10/01/2015', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002020,'Pantaln encerado en blanco. Cintura ancha, cierre con cremallera lateral.',
	'1/10/2015',p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002037,'Jersey de punto en color rojo con un pequeo calado. Manga larga. Cuello de pico.',
	'1/10/2015',p_RES,p_ERRDESC);

--Afegir tres nous productes. Han de donar error ja que manquen camps per informar.	
PRODUCTE_PKG.ALTA_PRODUCTE (NULL,'Chaqueta en color marron con forro acolchado de cuadros en medio cuerpo. Cuatro bolsillos delanteros. Cierre de cremallera. Bordado trasero.',
	'10/01/2015',p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002051,NULL,'25/11/2009',p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113002068,'Pantaln tejano skinny en color rosa. Tres bolsillos delanteros y dos traseros. Cierre de cremallera y botn.',
	NULL,p_RES,p_ERRDESC);

	
--	BAIXA PRODUCTE

--Donar de baixa 3 productes. No ha de donar error perqu existeixen i no estan donats de baixa
PRODUCTE_PKG.BAIXA_PRODUCTE (8452113002013,p_RES,p_ERRDESC);


--Donar de baixa producte. Ha de donar error perqu ja est donat de baixa.
PRODUCTE_PKG.BAIXA_PRODUCTE (8452113002013,p_RES,p_ERRDESC);

--Donar de baixa producte. Ha de donar error perqu no existeix.
PRODUCTE_PKG.BAIXA_PRODUCTE (8452113002051,p_RES,p_ERRDESC);	
	
	
--	MODIFICAR PRODUCTE

--Modificar 3 productes. No han de donar error ja que les dades sn correctes
PRODUCTE_PKG.MODIFICAR_PRODUCTE (8452113002020,'Top combinado de seda en color fucsia. Tirantes ajustables.',
	'1/10/2015',p_RES,p_ERRDESC);
	
--Modificar 2 productes. Ha de donar error ja que els productes no existeixen
PRODUCTE_PKG.MODIFICAR_PRODUCTE (8452113002051,'Jersey lana blanco','11/11/2015',p_RES,p_ERRDESC);
	
--Modificar 1 producte, ha de donar error perqu est donat de baixa
PRODUCTE_PKG.MODIFICAR_PRODUCTE (8452113002013,'Jersey lana blanco','11/11/2015',p_RES,p_ERRDESC);

--Modificar 3 productes. ha de donar error perqu hi ha camps no informats
PRODUCTE_PKG.MODIFICAR_PRODUCTE (NULL,'Top combinado de seda en color fucsia. Tirantes ajustables.',
	'1/10/2014',p_RES,p_ERRDESC);
PRODUCTE_PKG.MODIFICAR_PRODUCTE (8452113002020,NULL,'1/10/2014',p_RES,p_ERRDESC);
PRODUCTE_PKG.MODIFICAR_PRODUCTE (8452113002020,'Jersey de punto en color amarillo con un pequeo calado. Manga larga. Cuello de pico.',
	NULL,p_RES,p_ERRDESC);
	







/*************************************
*       BLOC DE PROVES BOTIGA        *
*************************************/

dbms_output.put_line(chr(13)||chr(13)||'TEST BOTIGA'||chr(13)||chr(13));

--    AFEGIR BOTIGA

--Afegir 3 botigues, s'han d'agefir correctament
BOTIGA_PKG.ALTA_BOTIGA (1,1,'prova@prova.com',4,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (2,78,'prova2@prova.com',10,1,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (3,90,'prova2@prova.com',3,1,1,p_RES,p_ERRDESC);

--Afegir 2 botigues. Han de donar error perqu ja existeixen
BOTIGA_PKG.ALTA_BOTIGA (1,78,'prova@prova.com',4,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (2,90,'prova2@prova.com',10,0,0,p_RES,p_ERRDESC);

--Afegir una botiga. Ha de donar error perqu la ciutat no existeix.
BOTIGA_PKG.ALTA_BOTIGA (4,300,'prova@prova.com',4,0,0,p_RES,p_ERRDESC);

--Afegir botigues. Han de donar error perqu manquen camps per informarBOTIGA_PKG.ALTA_BOTIGA (200,1,'prova@prova.com',4,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (204,NULL,'prova2@prova.com',10,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (205,1,NULL,4,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (206,78,'prova2@prova.com',NULL,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (207,1,'prova@prova.com',4,NULL,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (208,78,'prova2@prova.com',10,0,NULL,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (NULL,1,'prova@prova.com',4,0,0,p_RES,p_ERRDESC);

--Baixa botiga OK.
BOTIGA_PKG.BAIXA_BOTIGA (1,p_RES,p_ERRDESC);

--Baixa botiga. No es dona de baixa perqu no existeix.
BOTIGA_PKG.BAIXA_BOTIGA (300,p_RES,p_ERRDESC);

--Baixa botiga. No es dona de baixa perqu ja ho est.
BOTIGA_PKG.BAIXA_BOTIGA (1,p_RES,p_ERRDESC);



--Modificar Botiga. S'han de modificar correctament
BOTIGA_PKG.MODIFICAR_BOTIGA (2,69,'prova@prova.com',3,0,1,p_RES,p_ERRDESC);
BOTIGA_PKG.MODIFICAR_BOTIGA (3,29,'prova2@prova.com',5,1,1,p_RES,p_ERRDESC);

--Modificar botiga. No s'ha de modificar perqu no existeixen
BOTIGA_PKG.MODIFICAR_BOTIGA (300,69,'prova@prova.com',3,0,1,p_RES,p_ERRDESC);
BOTIGA_PKG.MODIFICAR_BOTIGA (301,29,'prova2@prova.com',5,1,1,p_RES,p_ERRDESC);

--Modificar botiga. No s'ha de modificar perqu est donada de baixa
BOTIGA_PKG.MODIFICAR_BOTIGA (1,69,'prova@prova.com',3,0,1,p_RES,p_ERRDESC);

--Modificar botiga. No s'ha de modificar perqu l'identificador de ciutat no existeix.
BOTIGA_PKG.MODIFICAR_BOTIGA (2,901,'prova@prova.com',3,0,1,p_RES,p_ERRDESC);
BOTIGA_PKG.MODIFICAR_BOTIGA (3,505,'prova2@prova.com',5,1,1,p_RES,p_ERRDESC);

--Modificar botiga. no s'ha de modificar perqu hem d'informar tots els camps.
BOTIGA_PKG.MODIFICAR_BOTIGA (NULL,69,'prova@prova.com',3,0,1,p_RES,p_ERRDESC);
BOTIGA_PKG.MODIFICAR_BOTIGA (2,NULL,'prova2@prova.com',5,1,1,p_RES,p_ERRDESC);
BOTIGA_PKG.MODIFICAR_BOTIGA (2,69,NULL,3,0,1,p_RES,p_ERRDESC);
BOTIGA_PKG.MODIFICAR_BOTIGA (2,29,NULL,5,1,1,p_RES,p_ERRDESC);


UPDATE BOTIGA SET dataBaixa='01/11/2015' WHERE idBotiga=1;
UPDATE PRODUCTE SET dataBaixa='01/11/2015' WHERE idProducte=8452113002013;


/*************************************
*       BLOC DE PROVES VENTA         *
*************************************/

dbms_output.put_line(chr(13)||chr(13)||'TEST VENTA'||chr(13)||chr(13));

--Afegir ventes. Ha de ser OK perqu aquestes ventes no estan registrades al sistema
--VENTA_PKG.ALTA_VENTA (botiga,producte,data,hora,unitats,preuTotal,benefici,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (1,8452113002020,'25/10/2015',9,1,44.3,30,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002013,'25/10/2015',10,2,15,8.3,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002037,'25/10/2015',11,1,14,7.3,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (3,8452113002020,'25/10/2015',12,1,23,13.51,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (3,8452113002037,'25/10/2015',13,1,19.99,10.78,p_RES,p_ERRDESC);

--Afegir venta. No s'ha d'afegir perqu ja existeix.
VENTA_PKG.ALTA_VENTA (1,8452113002020,'25/10/2015',9,1,13.99,3,p_RES,p_ERRDESC);

--Afegir venta. No s'ha d'afegir perqu la botiga no existeix.
VENTA_PKG.ALTA_VENTA (10,8452113002020,'25/10/2015',9,1,13.99,3,p_RES,p_ERRDESC);

--Afegir venta. No s'ha d'afegir perqu el producte no existeix.
VENTA_PKG.ALTA_VENTA (1,4,'25/10/2015',9,1,13.99,3,p_RES,p_ERRDESC);

--Afegir venta. no s'ha d'afegir perqu la botiga est donada de baixa en aquesta data.
VENTA_PKG.ALTA_VENTA (1,8452113002020,'02/11/2015',14,1,19.99,10.78,p_RES,p_ERRDESC);

--Afegir venta. No s'ha d'afegir perqu el producte no est en catleg aquesta data
VENTA_PKG.ALTA_VENTA (2,8452113002013,'02/11/2015',9,1,19.99,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002013,'01/09/2015',9,1,19.99,10.78,p_RES,p_ERRDESC);

--Afeir venta. No s'ha d'afegir perque un dels camps s null8452113001160
VENTA_PKG.ALTA_VENTA (null,8452113002037,'01/01/2015',9,1,19.99,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,null,'01/01/2015',9,1,19.99,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002037,null,9,1,19.99,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002037,'01/01/2015',null,1,19.99,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002037,'01/01/2015',9,null,19.99,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002037,'01/01/2015',9,1,null,10.78,p_RES,p_ERRDESC);
VENTA_PKG.ALTA_VENTA (2,8452113002037,'01/01/2015',9,1,19.99,null,p_RES,p_ERRDESC);

--Afegir venta. No s'ha d'afegir perqu l'hora no s correctament
VENTA_PKG.ALTA_VENTA (3,8452113002037,'01/10/2015',24,1,19.99,10.78,p_RES,p_ERRDESC);

--Modificar venta. S'ha de modificar perqu s correctes
VENTA_PKG.MODIFICAR_VENTA (2,8452113002013,'25/10/2015',10,1,7,4.3,p_RES,p_ERRDESC);

--Modificar venta. No s'ha de modificar perqu la venta no existeix.
VENTA_PKG.MODIFICAR_VENTA (2,8452113002013,'24/10/2015',10,1,7,4.3,p_RES,p_ERRDESC);
VENTA_PKG.MODIFICAR_VENTA (2,8452113002013,'25/10/2015',14,1,7,4.3,p_RES,p_ERRDESC);
VENTA_PKG.MODIFICAR_VENTA (3,8452113002013,'25/10/2015',10,1,7,4.3,p_RES,p_ERRDESC);
VENTA_PKG.MODIFICAR_VENTA (2,8452113002037,'25/10/2015',10,1,7,4.3,p_RES,p_ERRDESC);

--Modificar venta. No s'ha de modificar perqu hi ha camps sense informar.
VENTA_PKG.MODIFICAR_VENTA (null,8452113002013,'25/10/2015',10,1,7,4.3,p_RES,p_ERRDESC);
VENTA_PKG.MODIFICAR_VENTA (2,8452113002013,'25/10/2015',10,1,7,null,p_RES,p_ERRDESC);

--Eliminar venta. S'han d'eliminar perqu s correcte.
VENTA_PKG.BAIXA_VENTA (1,8452113002020,'25/10/2015',9,p_RES,p_ERRDESC);

--Eliminar venta. No s'ha d'eliminar perqu no existeix.
VENTA_PKG.BAIXA_VENTA (2,8452113002020,'25/10/2015',9,p_RES,p_ERRDESC);
VENTA_PKG.BAIXA_VENTA (1,8452113002020,'24/10/2015',9,p_RES,p_ERRDESC);


--Tornem a activar els triggers
EXECUTE IMMEDIATE 'ALTER TRIGGER TRIGGER_VENTA_EST ENABLE';


end;