declare
	p_RES int;
	p_ERRDESC VARCHAR2(150);
  CURSOR cVendes IS SELECT idBotiga, idProducte, dataVenta, horaVenta FROM VENTA;
  botiga INT;
  producte INT;
  dataV DATE;
  horaV INT;
begin

--Desactivem els triggers...
EXECUTE IMMEDIATE 'ALTER TRIGGER TRIGGER_VENTA_EST DISABLE';

DELETE FROM VENTA;
DELETE FROM ESTADISTICA;
DELETE FROM EST_BOTIGA;
DELETE FROM EST_CIUTAT;
DELETE FROM EST_DIA;
DELETE FROM EST_HORA;
DELETE FROM EST_PRODUCTE;
DELETE FROM EST_VIRTUAL;
DELETE FROM PRODUCTE;
DELETE FROM BOTIGA;
DELETE FROM CIUTAT;
DELETE FROM REGIO;

--Tornem a activar-los
EXECUTE IMMEDIATE 'ALTER TRIGGER TRIGGER_VENTA_EST ENABLE';

--Poblem la BDD amb ELS PRODUCTES, LES BOTIGUES, LES CIUTATS, I LES REGIONS
Insert into REGIO values ('2','Alt Empord');
Insert into REGIO values ('9','Baix Empord');
Insert into REGIO values ('10','Baix Llobregat');


Insert into CIUTAT values ('32','Calonge','9');
Insert into CIUTAT values ('50','Cornell de Llobregat','10');
Insert into CIUTAT values ('84','Llan','2');

BOTIGA_PKG.ALTA_BOTIGA (1,32,'conubia.nostra@Curabitur.ca',3,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (2,50,'eget@Nullam.org',2,1,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (5,84,'non.magna@Pellentesquehabitant.edu',5,0,1,p_RES,p_ERRDESC);

PRODUCTE_PKG.ALTA_PRODUCTE (8452113001221,'Chaqueta en color verde caki con forro acolchado de cuadros en medio cuerpo. Cuatro bolsillos delanteros. Cierre de cremallera. Bordado trasero.',
to_date('11/19/2009', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113001207,'Pantaln tejano skinny en color azul marino. Tres bolsillos delanteros y dos traseros. Cierre de cremallera y botn.',
to_date('01/20/2010', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113001016,'Falda tubo elstica en color negro. Ideal para todo tipo de looks, formales e informales.',
to_date('12/26/2012', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113000996,'Camiseta entallada de manga larga y cuello redondo con transparencia y print de cachemir.',
to_date('04/02/2013', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113001115,'Jersey de punto gordo jaspeado en azul y blanco. Cuello de pico y manga larga.',
to_date('02/13/2014', 'MM/DD/YYYY'),p_RES,p_ERRDESC);

--Afegim vendes
VENTA_PKG.ALTA_VENTA (1,8452113001221,'1/10/2015',10,1,59.99,21.99,p_RES,p_ERRDESC); --1
VENTA_PKG.ALTA_VENTA (1,8452113000996,'1/10/2015',10,1,15.95,10.05,p_RES,p_ERRDESC); --2
VENTA_PKG.ALTA_VENTA (2,8452113001207,'1/10/2015',14,1,69.99,30.10,p_RES,p_ERRDESC); --3
VENTA_PKG.ALTA_VENTA (2,8452113001016,'1/10/2015',15,1,35,15.50,p_RES,p_ERRDESC); --4
VENTA_PKG.ALTA_VENTA (5,8452113001115,'1/10/2015',20,1,40,25,p_RES,p_ERRDESC); --5
VENTA_PKG.ALTA_VENTA (5,8452113001221,'1/10/2015',23,1,59.99,18.75,p_RES,p_ERRDESC); --6
VENTA_PKG.ALTA_VENTA (1,8452113000996,'2/10/2015',13,2,30,20.10,p_RES,p_ERRDESC); --7
VENTA_PKG.ALTA_VENTA (1,8452113001207,'2/10/2015',14,1,69.99,25.95,p_RES,p_ERRDESC); --8
VENTA_PKG.ALTA_VENTA (2,8452113000996,'2/10/2015',15,1,15.95,9,p_RES,p_ERRDESC); --9
VENTA_PKG.ALTA_VENTA (1,8452113001115,'2/10/2015',15,2,80,43,p_RES,p_ERRDESC); --10
VENTA_PKG.ALTA_VENTA (2,8452113001207,'3/10/2015',16,1,69.99,23,p_RES,p_ERRDESC); --11
VENTA_PKG.ALTA_VENTA (2,8452113001221,'3/10/2015',17,1,59.99,30,p_RES,p_ERRDESC); --12
VENTA_PKG.ALTA_VENTA (1,8452113001115,'3/10/2015',17,1,40,23,p_RES,p_ERRDESC); --13
VENTA_PKG.ALTA_VENTA (2,8452113001016,'3/10/2015',18,1,35,16,p_RES,p_ERRDESC); --14
VENTA_PKG.ALTA_VENTA (5,8452113000996,'3/10/2015',18,2,15.95,11,p_RES,p_ERRDESC); --15
VENTA_PKG.ALTA_VENTA (1,8452113001115,'4/10/2015',18,1,40,20,p_RES,p_ERRDESC); --16
VENTA_PKG.ALTA_VENTA (1,8452113001207,'4/10/2015',19,1,69.99,25.5,p_RES,p_ERRDESC); --17
VENTA_PKG.ALTA_VENTA (5,8452113001016,'4/10/2015',19,1,35,18,p_RES,p_ERRDESC); --18
VENTA_PKG.ALTA_VENTA (2,8452113001221,'5/10/2015',20,1,59.99,22,p_RES,p_ERRDESC); --19
VENTA_PKG.ALTA_VENTA (5,8452113000996,'5/10/2015',3,1,14,9,p_RES,p_ERRDESC); --20


dbms_output.put_line('');
dbms_output.put_line('Provem les estadstiques per al 2015:'); 
dbms_output.put_line('');
--Estadstica per un any amb vendes registrades
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(2015);
--Estadstica histrica
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(0);


dbms_output.put_line('');
dbms_output.put_line('Fem canvis sobre les vendes i en tornem a visualitzar les estadstiques per veure els canvis'); 
dbms_output.put_line('');
VENTA_PKG.ALTA_VENTA (2,8452113001221,'1/1/2014',10,4,240,65,p_RES,p_ERRDESC); --21
VENTA_PKG.ALTA_VENTA (2,8452113000996,'2/12/2014',10,1,15.95,10.05,p_RES,p_ERRDESC); --22
VENTA_PKG.ALTA_VENTA (5,8452113001207,'3/1/2014',14,1,69.99,30.10,p_RES,p_ERRDESC); --23
VENTA_PKG.ALTA_VENTA (5,8452113001016,'4/2/2014',15,2,70,30,p_RES,p_ERRDESC); --24
VENTA_PKG.ALTA_VENTA (5,8452113001115,'5/3/2014',20,1,40,25,p_RES,p_ERRDESC); --25
VENTA_PKG.ALTA_VENTA (5,8452113001221,'6/4/2014',23,1,59.99,18.75,p_RES,p_ERRDESC); --26
VENTA_PKG.ALTA_VENTA (5,8452113000996,'7/4/2014',13,2,30,20.10,p_RES,p_ERRDESC); --27
VENTA_PKG.ALTA_VENTA (5,8452113001207,'8/10/2014',14,1,69.99,25.95,p_RES,p_ERRDESC); --28
VENTA_PKG.ALTA_VENTA (2,8452113000996,'9/11/2014',15,1,15.95,9,p_RES,p_ERRDESC); --29
VENTA_PKG.ALTA_VENTA (5,8452113001115,'10/9/2014',15,2,80,43,p_RES,p_ERRDESC); --30
VENTA_PKG.ALTA_VENTA (2,8452113001207,'11/9/2014',16,1,69.99,23,p_RES,p_ERRDESC); --31
VENTA_PKG.ALTA_VENTA (2,8452113001221,'13/7/2014',17,1,59.99,30,p_RES,p_ERRDESC); --32
VENTA_PKG.ALTA_VENTA (5,8452113001115,'14/8/2014',17,1,40,23,p_RES,p_ERRDESC); --33
VENTA_PKG.ALTA_VENTA (2,8452113001016,'15/6/2014',18,1,35,16,p_RES,p_ERRDESC); --34
VENTA_PKG.ALTA_VENTA (5,8452113000996,'16/6/2014',18,2,15.95,11,p_RES,p_ERRDESC); --35
VENTA_PKG.ALTA_VENTA (5,8452113001115,'17/4/2014',18,3,120,60,p_RES,p_ERRDESC); --36
VENTA_PKG.ALTA_VENTA (5,8452113001207,'20/4/2014',19,1,69.99,25.5,p_RES,p_ERRDESC); --37
VENTA_PKG.ALTA_VENTA (5,8452113001016,'21/7/2014',19,1,35,18,p_RES,p_ERRDESC); --38
VENTA_PKG.ALTA_VENTA (2,8452113001221,'22/10/2014',20,1,59.99,22,p_RES,p_ERRDESC); --39
VENTA_PKG.ALTA_VENTA (5,8452113000996,'25/10/2014',3,1,14,9,p_RES,p_ERRDESC); --40
VENTA_PKG.BAIXA_VENTA (1,8452113001207,'4/10/2015',19,p_RES,p_ERRDESC); --41
VENTA_PKG.BAIXA_VENTA (1,8452113001115,'4/10/2015',18,p_RES,p_ERRDESC); --42
VENTA_PKG.BAIXA_VENTA (1,8452113001115,'3/10/2015',17,p_RES,p_ERRDESC); --43
VENTA_PKG.BAIXA_VENTA (1,8452113001115,'2/10/2015',15,p_RES,p_ERRDESC); --44
VENTA_PKG.BAIXA_VENTA (5,8452113001115,'1/10/2015',20,p_RES,p_ERRDESC); --45
VENTA_PKG.MODIFICAR_VENTA (1,8452113000996,'2/10/2015',13,1,15,10,p_RES,p_ERRDESC); --46
VENTA_PKG.MODIFICAR_VENTA (2,8452113001016,'1/10/2015',15,3,105,45,p_RES,p_ERRDESC); --47
VENTA_PKG.MODIFICAR_VENTA (2,8452113001016,'3/10/2015',18,2,70,30.2,p_RES,p_ERRDESC); --48
VENTA_PKG.MODIFICAR_VENTA (5,8452113001016,'4/10/2015',19,2,69.98,29.98,p_RES,p_ERRDESC); --49
--Estadstica per un any amb vendes registrades
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(2015);
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(2014);
--Estadstica histrica
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(0);


dbms_output.put_line('');
dbms_output.put_line('Provem les diferents situacions d'||chr(39)||'Error:'); 
dbms_output.put_line('');

--Ha de donar error perqu l'any no s correcte
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(15);

--Ha de donar error perqu no hi ha vendes registrades per aquest any
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(2000);

OPEN cVendes;
LOOP
  FETCH cVendes INTO botiga, producte, dataV, horaV;
  EXIT WHEN cVendes%NOTFOUND;
  VENTA_PKG.BAIXA_VENTA (botiga,producte,dataV,horaV,p_RES,p_ERRDESC);
END LOOP;
CLOSE cVendes;

--Estadstica histrica: ha de donar error perqu no hi ha dades registrades al sistema.
ESTADISTIC_PKG.MOSTRAR_ESTADISTICA(0);


end;